function Interface() {

  var t = this,
    bridge, mu = "http://map.sogou.com/#",
    waitOpen = false;
  var _webInfo = function() {
    return {
      "title": "",
      "url": "",
      "type": "0",
      "toolBar": "0",
      "backButtonStyle": "0"
    }
  }
  var _appInfo = function() {
    return {
      "name": "", //应用程序名称
      "size": "", //应用程序包大小
      "url": "", //应用程序下载地址
      "versionCode": "", //应用程序版本号
      "versionName": "", //应用程序版本名称
      "updateTime": "", //应用程序更新时间
      "changeLog": "" //更新信息
    }
  }
  var _shareInfo = function() {
    return {
      "url": "", //分享的url
      "desc": "", //短链分享描述信息
      "imgUrl": "", //短链图片获取url
      "previewImageUrl": "" //分享alert的预览提示图片
    }
  }
  var _poiInfo = function() {
    return {
      "name": "", //名称
      "address": "", //地址
      "phone": "", //电话
      "dataid": "", //dataid
      "cpid": "", //cpid
      "uid": "", //uid
      "type": "", //0：其他类 1：餐饮类 2：酒店类
      "coordx": "", //墨卡托坐标x
      "coordy": "" //墨卡托坐标y
    }
  }
  var times = {}; //延时的等待对象
  var cbFunction; //客户端回调函数


  //ios系统
  document.addEventListener('WebViewJavascriptBridgeReady', onBridgeReady, false);

  function onBridgeReady(event) {
    bridge = event.bridge
    bridge.init();
    //回调监听
    bridge.registerHandler('iosCalJavascript', function(data) {
      cbFunction(data);
    })
  }

  //android系统回调
  window.androidCalWebView = function(data) {
    cbFunction(unescape(unescape(data)));
  }

  //发送
  //a	类型
  //b	参数
  //c	返回
  this.send = function(a, b) {
    //整理参数
    var p = crParam(a, b);
    if (waitOpen) {
      return;
    }
    //关闭可能的等待，当前相同的
    clearTimeout(times[a]);
    //发送
    if (bridge) {
      bridge.send(p);
    } else if (window.android && window.android.webViewCalAndroid) {

      p = obj2str(p);
      window.android.webViewCalAndroid(p);
    } else {
      //if(!moblog){
      //var moblog="";
      if (a == "openWeb" || a == "openWithBrowser" || a == "showActivity") {
        window.location.href = b.webInfo.url;
      }
      if (a == "showOnMap") {
        if (b.poiInfo.uid) {
          window.location.href = mu + "uids=" + b.poiInfo.uid;
        } else if (b.poiInfo.dataid) {
          window.location.href = mu + "dataid=" + b.poiInfo.dataid;
        } else {
          window.location.href = mu + "tip=" + escape(b.poiInfo.name) + "," + b.poiInfo.coordx + "," + b.poiInfo.coordy;
        }
      }
      if (a == "showSubject") {
        window.location.href = b.webInfo.url;
      }
      //}
      //等待苹果情况下的延时
      if (a == "setPoiData" || a == "setNavigationBarTitle" || a == "mapOrigin" || a == "toolBarOrigin") {
        wait(a, b);
      }
    }
    //如果是指定提交，等待一秒。
    if (a == "openWeb" || a == "showOnMap") {
      waitOpen = true;
      setTimeout(function() {
        waitOpen = false;
      }, 1000)
    }
  }

  //如果是返回共享信息，那么，等待指定次数次
  function wait(a, b, n) {
    //关闭等待
    clearTimeout(times[a]);
    //
    if (!n) {
      n = 12
    }
    //有了就提交
    if (bridge) {
      t.send(a, b);
      return;
    }
    //到次数就停止
    if (n == 1) {
      return;
    }
    //否则循环
    times[a] = setTimeout(function() {
      wait(a, b, n - 1);
    }, 200)
  }

  //整理参数
  function crParam(a, b) {
    b["WTON_ACTION"] = a;
    return b;
  }

  //返回webinfo
  this.getNewWebInfo = function() {
    return _webInfo();
  }
  //返回appinfo
  this.getNewAppInfo = function() {
    return _appInfo();
  }
  //返回shareinfo
  this.getNewShareInfo = function() {
    return _shareInfo();
  }
  //返回poiinfo
  this.getNewPoiInfo = function() {
    return _poiInfo();
  }

  //设置客户端的回调
  this.setCallBack = function(a) {
    cbFunction = a;
  }

  //参数编码
  function obj2str(o) {
    var r = [],
      b;
    if (typeof o == "string") return "\"" + escape(o.replace(/([\'\"\\])/g, "\\$1").replace(/(\n)/g, "\\n").replace(/(\r)/g, "\\r").replace(/(\t)/g, "\\t")) + "\"";
    if (typeof o == "undefined") return "";
    if (typeof o == "object") {
      if (o === null) return "null";
      else if (!o.sort || !o.length) {
        for (var i in o) {
          b = /[^\w]/.test(i);
          if (i != "getClassName" && i != "setTimeout" && i != "eventHandler") r.push("\"" + i + "\"" + ":" + obj2str(o[i]))
        }
        r = "{" + r.join() + "}"
      } else {
        for (var i = 0; i < o.length; i++) r.push(obj2str(o[i]));
        r = "[" + r.join() + "]"
      }
      return r;
    }
    return o.toString();
  }

}